
Global Const $sFile_Src = 'BlackWhite.bmp' ; Aus Src wird in kleinen Stcken der
Global Const $sFile_Dst = 'AutoItWallpaper.bmp' ; Inhalt von Dst nachgebildet und in
Global Const $sFile_Rea = 'Rea' & Random(1000,9999, 1) & '.png' ; Rea gespeichert.
Global Const $iPixelSize = 16 ; Gre der Stcke


#include 'INC\I2D_Nano.au3'
#include 'INC\DllStructProtected.au3'
#include 'INC\StructStack.au3'

#include <GDIPlus.au3>
#include <Array.au3>

_GDIPlus_Startup()
Global $IMG_Src = _I2D_BufferCreateFromFile($sFile_Src)
Global $IMG_Dst = _I2D_BufferCreateFromFile($sFile_Dst)
Global $IMG_Rea = _I2D_BufferCreate($IMG_Src.WIDTH, $IMG_Src.HEIGHT)

Global $t = TimerInit()
_Reassemble($IMG_Rea, $IMG_Src, $IMG_Dst)
ConsoleWrite(StringFormat('%.0f', TimerDiff($t)) & @CRLF)

; Times for PixelSize 16, 512x512 Bitmap
; 15,239 - Originalzeit
; 14,410 - Benutzung von int;int Stack statt Array (sodass Arraydelete entfllt)
; 13,858 - Ersetzung von Strings zum Shufflen durch ein Array[n][2]
; 13,183 - Tooltip nur noch alle 100ms statt jedes Mal
; 13,173 - Ubounds durch $dx und $dy ersetzt (die Werte waren schon vorher bekannt)
; 12,842 - IsDllStruct fr DST entfernt, da jedes Bild eh nur 1x im Stack ist.
; 11,172 - Ersetzung des aIMG_SRC[dy][dx] Puffers durch einen linearen Puffer der fr gefundene Bilder nicht mehr komplett durchsucht werden muss.


; Times for PixelSize 32, 512x512 Bitmap
; 1,247
; 1,193
; 1,151
; 1,001
;   998
;   958
;   865

_I2D_BufferSaveToFile($IMG_Rea, $sFile_Rea)

_I2D_BufferDelete($IMG_Src)
_I2D_BufferDelete($IMG_Dst)
_I2D_BufferDelete($IMG_Rea)

_GDIPlus_Startup()

Func _Reassemble($rea, $src, $dst)

	Local $px = $iPixelSize
	Local $dy = Int(Round($rea.HEIGHT / $px, 0))
	Local $dx = Int(Round($rea.WIDTH / $px, 0))

	Local $aIMG_Dst[$dy][$dx]
	Local $aIMG_Rea[$dy][$dx]


	Local $aIMG_SrcLinear[$dx*$dy], $iUBound_SrcLinear = $dx * $dy,  $iPos_SrcLinear
	Local $aDIF_Linear[$dx*$dy], $aIMG_Tmp, $aPosDst[2]
	; Idee ist:
	; m = $dx * $dy
	; Im Array [0 bis m] wird ein Bild gefunden
	; Das Bild wird mit dem letzten Bild vertauscht
	; m -= 1
	; Beim nchsten Durchlauf mssen nur noch m-1 Elemente untersucht werden

	Local $aCoord[$dx*$dy][2]
	Local $iTimerTooltip = TimerInit()

	For $y = 0 To $dy - 1 Step 1
		For $x = 0 To $dx - 1 Step 1
			$aIMG_SrcLinear[$y * $dx + $x] = _I2D_BufferExtractArea($src, $x * $px, $y * $px, $px, $px)
			$aIMG_Dst[$y][$x] = _I2D_BufferExtractArea($dst, $x * $px, $y * $px, $px, $px)
			$aCoord[$y * $dx + $x][0] = $x
			$aCoord[$y * $dx + $x][1] = $y
		Next
	Next

	_ArrayShuffleNx2ForN($aCoord)

	Local $Stack = SSCreate('int;int'), $tmp
	For $i = 0 To UBound($aCoord) - 1 Step 1
		SSPush2int($Stack, $aCoord[$i][0], $aCoord[$i][1])
	Next

	For $i = 0 To $dx*$dy - 1 Step 1

		If TimerDiff($iTimerTooltip) > 100 Then
			ToolTip(StringFormat('%.0f', 4.03*log(1+100*($i)/($dx*$dy))^2.1) & '%')
			$iTimerTooltip = TimerInit()
		EndIf

		$aPosDst = SSPop2int($Stack)

		For $ii = 0 To $iUBound_SrcLinear - 1 Step 1
			$aDIF_Linear[$ii] = _I2D_BufferCalcDif($aIMG_Dst[$aPosDst[1]][$aPosDst[0]], $aIMG_SrcLinear[$ii])
		Next

		$iPos_SrcLinear = _ArrayMinIndex1D($aDIF_Linear, $iUBound_SrcLinear)
		$aIMG_Rea[$aPosDst[1]][$aPosDst[0]] = $aIMG_SrcLinear[$iPos_SrcLinear]
		$aIMG_Tmp = $aIMG_SrcLinear[$iUBound_SrcLinear - 1]
		$aIMG_SrcLinear[$iUBound_SrcLinear - 1] = $aIMG_SrcLinear[$iPos_SrcLinear]
		$aIMG_SrcLinear[$iPos_SrcLinear] = $aIMG_Tmp
		$iUBound_SrcLinear -= 1

		_I2D_BufferDelete($aIMG_Dst[$aPosDst[1]][$aPosDst[0]])
		$aIMG_Dst[$aPosDst[1]][$aPosDst[0]] = -1

	Next

	For $y = 0 To $dy - 1 Step 1
		For $x = 0 To $dx - 1 Step 1
			_GDIPlus_GraphicsDrawImageRect($rea.GFX, $aIMG_Rea[$y][$x].BMP, $x * $px, $y * $px, $px, $px)
			_I2D_BufferDelete($aIMG_Rea[$y][$x])
		Next
	Next

EndFunc

Func _ArrayShuffleNx2ForN(ByRef $aArray) ; den Spezialfall fr Nx2 rausholen macht hier einiges flotter
	Local $iUBound = UBound($aArray), $vTmp1, $vTmp2, $iRand
	For $i = $iUBound - 1 To 1 Step -1
		$iRand = Random(0, $i, 1)
		$vTmp1 = $aArray[$i][0]
		$vTmp2 = $aArray[$i][1]
		$aArray[$i][0] = $aArray[$iRand][0]
		$aArray[$i][1] = $aArray[$iRand][1]
		$aArray[$iRand][0] = $vTmp1
		$aArray[$iRand][1] = $vTmp2
	Next
EndFunc

Func _ArrayMinIndex1D($aArray, $iUntil)
	If Not IsArray($aArray) Then Return $aArray
	Local $iMin = $aArray[0], $iMinIndex = 0
	For $i = 1 To $iUntil - 1 Step 1
		If $aArray[$i] < $iMin Then
			$iMin = $aArray[$i]
			$iMinIndex = $i
		EndIf
	Next
	Return $iMinIndex
EndFunc